import {
    select,
    csv,
    scaleLinear,
    max,
    scaleBand,
    axisLeft,
    axisBottom,
  	format
} from 'd3'

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
    const xValue = d => d.startdataarea;
    const yValue = d => d.usageid;
    const margin = { top: 50, right: 40, bottom: 75, left: 170 };
    const innerWidth = width - margin.left - margin.right;
    const innerHeight = height - margin.top - margin.bottom;

    const xScale = scaleLinear()
        .domain([0, max(data, xValue)])
        .range([0, innerWidth]);

    const yScale = scaleBand()
        .domain(data.map(yValue))
        .range([0, innerHeight])
        .padding(0.1);

    const g = svg.append('g')
        .attr('transform', `translate(${margin.left},${margin.top})`);
  
  	const xAxis = axisBottom(xScale)
    	.tickSize(- innerHeight);
  
    g.append('g')
      .call(axisLeft(yScale))
  		.selectAll('.domain, .tick line')
  			.remove();
  	
    const xAxisG = g.append('g').call(xAxis)
    	.attr('transform', `translate(0,${innerHeight})`);
  
  	xAxisG.select('.domain').remove();  
  
		xAxisG.append('text')
  		.attr('class', 'axis-label')
  		.attr('y', 60)
  		.attr('x', innerWidth / 2)
  		.attr('fill', 'black')
  		.text('Jaren');

    g.selectAll('rect').data(data)
        .enter().append('rect')
        .attr('y', d => yScale(yValue(d)))
        .attr('width', d => xScale(xValue(d)))
        .attr('height', yScale.bandwidth());
  
		g.append('text')
  		.attr('class', 'title')
  		.attr('y', -10)
  		.text('Hoeveel PenRs per jaar');
};

csv('data.csv').then(data => {
    data.forEach(d => {
        d.startdataarea = +d.startdataarea;
      
      let yearData = [0, 100, 20, 100, 15];
      const countOccurrences = function(arr, val) {
        return arr.reduce((acc, elem) => {
          return (val === elem ? acc + 1 : acc)
        }, 0) 
      };
      console.log(countOccurrences(yearData, 100))
      
    });
  	console.log(data)
  	
  	// let yearData = data;
  	// const countOccurrences = function(arr, val) {
  	// return arr.reduce((acc, elem) => {
  	// return (val === elem ? acc + 1 : acc)
  	// }, 0) 
  	// };
  	// console.log(countOccurrences(yearData))
    render(data);
})